<script setup lang="ts">
import Intervention from "../types/intervention";
import Picture from "../types/picture";
import Tag from "../types/tag";

const { baseURL }: { baseURL: string } = useRuntimeConfig().app;
const { id } = useRoute().params;
const authorizationHeader = useAuthorizationHeader("application/json");
const { data: intervention } = await useFetch<Intervention>(
  baseURL + "api/interventions/" + id,
  {
    headers: authorizationHeader,
  }
);

const inputDate: string = intervention.value.createdAt;
const formattedDate: string = useFormatDate(inputDate);

let photosApres: Picture[] = [];
let photosAvant: Picture[] = [];

for (const picture of intervention.value.pictures) {
  if (picture.tags && picture.tags.length > 0) {
    const hasApresTag: boolean = picture.tags.some((tag: Tag) => tag.name === "Après");
    const hasAvantTag: boolean = picture.tags.some((tag: Tag) => tag.name === "Avant");

    if (hasApresTag) {
      photosApres.push(picture);
    } else if (hasAvantTag) {
      photosAvant.push(picture);
    }
  }
}

const photosInDesiredOrder: Picture[] = [...(photosApres || []), ...(photosAvant || [])];
</script>

<template>
  <div v-if="intervention !== null">
    <div class="participants-container fr-grid-row fr-grid-row--middle fr-p-2w">
      <div class="fr-grid-row avatar-container">
        <div
          class="agent-avatar"
          v-for="agent in intervention.participants"
        >
          <img
            v-if="agent.picture"
            :src="agent.picture"
            class="agent-photo"
            :alt="`Photo de ${agent.firstname} ${agent.lastname}`"
          />
          <div v-else class="agent-initials">
            {{ getInitials(agent) }}
          </div>
        </div>
      </div>
  
      <div class="participants-name fr-ml-3w">
        <p
          class="fr-pt-1v"
          v-for="(agent, index) in intervention.participants"
          :key="index"
        >
          {{ agent.firstname }} {{ agent.lastname
          }}{{ index < intervention.participants.length - 1 ? ", &nbsp;" : "" }}
        </p>
      </div>
    </div>
  
    <article class="fr-p-2w">
      <div v-if="photosInDesiredOrder.length > 1" class="scrollable-container">
        <ul class="scrollable-list">
          <li v-for="picture in photosInDesiredOrder" :key="picture.id">
            <p class="fr-tag tags-images" v-if="picture.tags.length > 0">
              {{ picture.tags[0].name }}
            </p>
            <img
              class="fr-responsive-img fr-mr-2w"
              :src="picture.URL"
              :alt="`${picture.tags[0].name} intervention`"
            />
          </li>
        </ul>
      </div>
      <div v-else-if="intervention.pictures.length === 1">
        <img
          class="fr-responsive-img fr-mb-2w"
          :src="intervention.pictures[0].URL"
          :alt="`${intervention.pictures[0].tags[0].name} intervention`"
          width="345"
          height="345"
        />
      </div>
      <div v-else>
        <img
          :src="`${intervention.type.picture}`"
          :alt="`${intervention.type.picture}`"
          class="fr-responsive-img fr-mb-2w"
          width="345"
          height="345"
        />
      </div>
      <div class="fr-grid-row fr-grid-row--middle fr-mt-2w">
        <h2 class="fr-col-9">{{ intervention.type.name }}</h2>
        <button
          :class="['fr-tag', { urgent: intervention.priority.slug === 'urgent' }]"
        >
          {{ intervention.priority.name }}
        </button>
      </div>
  
      <p class="fr-pt-2w">
        <span class="fr-icon-map-pin-2-line fr-pr-1v"></span
        >{{ intervention.location.rest }} {{ intervention.location.street }}
        {{ intervention.location.postcode }} {{ intervention.location.city }}
      </p>
      <p class="fr-pt-1w">
        <span class="fr-icon-calendar-2-line fr-pr-1w"></span>Publiée
        {{ formattedDate }} par {{ intervention.author.firstname }}
        {{ intervention.author.lastname }}
      </p>
      <p class="fr-pt-1w">
        <span class="fr-icon-draft-line fr-pr-1w"></span
        >{{ intervention.category.name }}
      </p>
      <slot name="réalisée" />
      <p class="fr-my-3w">{{ intervention.description }}</p>
      <slot />
  
      <slot name="carte" />
    </article>
    <hr />
    <InterventionComments />
  </div>
</template>

<style scoped>
.agent-initials {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 38px;
  height: 38px;
  line-height: 38px;
  text-align: center;
  font-weight: bold;
  font-size: 16px;
  background-color: var(--blue-france-925-125);
  color: var(--blue-france-sun-113-625);
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}
.agent-avatar {
  position: relative;
  width: 38px;
  height: 38px;
  margin-right: -12px;
}

.agent-photo {
  position: absolute;
  top: 0;
  left: 0;
  width: 38px;
  height: 38px;
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}

.participants-container {
  display: flex;
  flex-wrap: nowrap;
  flex-direction: row;
  background-color: #f6f6f6;
}

.avatar-container {
  display: flex;
  flex-wrap: wrap;
}

.participants-name {
  display: flex;
  flex-wrap: wrap; 
  white-space: nowrap;
  overflow: hidden; 
}

.scrollable-container {
  width: 100%;
  overflow-x: auto;
}

.scrollable-list {
  white-space: nowrap;
}

.scrollable-list li {
  display: inline-block;
  vertical-align: top;
}

.scrollable-list img {
  width: 237px;
  height: 237px;
}

li {
  list-style: none;
  position: relative;
}

p.tags-images {
  position: absolute;
  top: 0.5rem;
  left: 0.5rem;
  z-index: 0;
}

h2 {
  font-size: 1.25rem;
}
.urgent {
  background-color: var(--background-action-high-warning);
  color: var(--text-inverted-blue-france);
}
</style>
